﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace CustomFontSR
{
    public sealed class CustomFontResolver : GrapeCity.ActiveReports.IFontResolver
    {
        static readonly GrapeCity.Documents.Text.FontCollection _fonts = new GrapeCity.Documents.Text.FontCollection();
        static CustomFontResolver()
        {
            _fonts.Clear();
            var assembly = Assembly.GetExecutingAssembly();
            var fontnames = assembly.GetManifestResourceNames().Where(str => str.EndsWith(".ttf"));
            foreach (var fontname in fontnames)
            {
                Stream stream = assembly.GetManifestResourceStream(fontname);
                _fonts.Add(GrapeCity.Documents.Text.Font.FromStream(stream));
            }
            _fonts.DefaultFont = _fonts.FindFamilyName("Arial");
        }
        public static GrapeCity.ActiveReports.IFontResolver Instance = new CustomFontResolver();
        private CustomFontResolver() { }
        GrapeCity.Documents.Text.FontCollection GrapeCity.ActiveReports.IFontResolver.GetFonts(string familyName, bool isBold, bool isItalic)
        {
            var fonts = new GrapeCity.Documents.Text.FontCollection();
            var font = _fonts.FindFamilyName(familyName, isBold, isItalic);
            if (font != null) fonts.Add(font);
            fonts.Add(_fonts.DefaultFont);
            return fonts;
        }
    }
}
